--Reporting script for supporting procurment information to be published
--Postcode list for CMZs with "PROCUREMENT" status

--POSTCODE_LOOKUP for all primary subsation is joined with PRIMARY_SUBSTATIONS table
--this is further joined with CMZ_INFORMATION table
--CMZs witha "PROCURMENT" satus are selected
--table columns selected and post codes are formatted

--Query take just over 60 seconds to run!!
--Ryan Kavanagh 11/06/2021

select 
--statement to format postcode
	case
	--check if there is already a space in the postcode - just return the post code
		when instr(POSTCODE_LOOKUP.Postcode, ' ') > 1 then 
		POSTCODE_LOOKUP.Postcode
	--check if there are no spaces - format the postcode
		when instr(POSTCODE_LOOKUP.Postcode, ' ') = 0 then 
		substr(POSTCODE_LOOKUP.Postcode, 0, length(POSTCODE_LOOKUP.Postcode)-3) || ' ' || substr(POSTCODE_LOOKUP.Postcode, length(POSTCODE_LOOKUP.Postcode)-2)
	end 							AS "Postcode",
	
	--data columns selected and renamed
	CMZ_INFORMATION.CMZ_CODE 		AS "CMZ Code",
	CMZ_INFORMATION.FRIENDLY_NAME	AS "CMZ Name",
	CMZ_INFORMATION.LICENCE_AREA 	AS "Licence Area",
	CMZ_INFORMATION.PRODUCT 		AS "Flexibility Product",
	PRIMARY_SUBSTATIONS.NAME 		AS "Primary Substation Name",
	PRIMARY_SUBSTATIONS.PRIM_NRID 	,
	PRIMARY_SUBSTATIONS.NR 			 
	
from

POSTCODE_LOOKUP																--startd with POSTCODE_LOOKUP table and filter down the results of interest
inner join																	--inner join PRIMARY_SUBSTATIONS table using PRIM_NRID
	PRIMARY_SUBSTATIONS
		on	PRIMARY_SUBSTATIONS.PRIM_NRID = POSTCODE_LOOKUP.PRIM_NRID
inner join
	CMZ_INFORMATION															--inner join CMZ_INFORMATION table using CMZ_CODE
		on PRIMARY_SUBSTATIONS.CMZ_CODE = CMZ_INFORMATION.CMZ_CODE

--filter results of interest
Where		
	CMZ_INFORMATION.TRANCHE_STATUS = 'PROCUREMENT' 